<!DOCTYPE html>
<html>
    <head>
        <title>
            Creación de Páginas Web Nivel 2
        </title>
        <link rel="stylesheet" type="text/css" href="css/index_style.css"/>
        <link  rel="stylesheet" href="https://fonts.googleapis.com/css?family=Karla:400,400i,700,700i&ampdisplay=swap">
    </head>
    <body>
        <div id="whole">
            <div id="upper">
                <h1>
                    CREACIÓN DE PÁGINAS WEB NIVEL 2
                </h1>
            </div>
            <div id="middle">
                <div id="lateral">
                    <center>
                        <h5>
                            TABLA DE CONTENIDO
                        </h5> 
                    </center>
                    <ul>
                        <li>
                            <a href="#objetos">
                                Objetos
                            </a>
                        </li>
                        <li>
                            <a href="#clases">
                                Clases
                            </a>
                        </li>
                        <li>
                            <a href="#caracteristicas">
                                Características
                            </a>
                        </li>
                        <li>
                            <a href="#ventajas">
                                Ventajas y Desventajas
                            </a>
                        </li>
                    </ul>
                </div>
                <div id="main">
                    <h2>
                        SESIÓN 4: OBJETOS Y CLASES
                    </h2>
                    
                    <h3 id="objetos">
                        Objetos
                    </h3>
                    <p align="justify">
                      JavaScript dispone de fuertes capacidades de programación orientada a objetos, a pesar de que han tenido lugar algunos debates respecto a las diferencias de sus capacidades en comparación con otros lenguajes.
                    <p align="justify">
                      Este artículo comienza con una Introducción a la programación orientada a objetos, luego examina el modelo de objetos de JavaScript, y finalmente, muestra los conceptos de programación orientada a objetos en JavaScript.
                    <p align="justify">
                      La programación orientada a objetos es un paradigma de programación que utiliza la abstracción para crear modelos basados ​​en el mundo real. Utiliza diversas técnicas de paradigmas previamente establecidas, incluyendo la modularidad, polimorfismo y encapsulamiento. Hoy en día, muchos lenguajes de programación (como Java, JavaScript, C#, C++, Python, PHP, Ruby y Objective-C) soportan programación orientada a objetos (POO).
                    <p align="justify">
                      La programación orientada a objetos puede considerarse como el diseño de software a través de un conjunto de objetos que cooperan, a diferencia de un punto de vista tradicional en el que un programa puede considerarse como un conjunto de funciones, o simplemente como una lista de instrucciones para la computadora. En la programación orientada a objetos, cada objeto es capaz de recibir mensajes, procesar datos y enviar mensajes a otros objetos. Cada objeto puede verse como una pequeña máquina independiente con un papel o responsabilidad definida.
                    <p align="justify">
                      POO pretende promover una mayor flexibilidad y facilidad de mantenimiento en la programación y es muy popular en la ingeniería de software a gran escala. Gracias a su fuerte énfasis en la modularidad, el código orientado a objetos está concebido para ser más fácil de desarrollar y más fácil de entender posteriormente, prestándose a un análisis más directo, a una mayor codificación y comprensión de situaciones y procedimientos complejos que otros métodos de programación menos modulares.
                    <h3 id="clases">
                        Clases
                    </h3>
                    <p align="justify">
                      Las clases de javascript, introducidas en ECMAScript 2015, son una mejora sintáctica sobre la herencia basada en prototipos de JavaScript. La sintaxis de las clases no introduce un nuevo modelo de herencia orientada a objetos en JavaScript. Las clases de JavaScript proveen una sintaxis mucho más clara y simple para crear objetos y lidiar con la herencia.
                    <p align="justify">
                      Las clases son "funciones especiales", como las expresiones de funciones y declaraciones de funciones, la sintaxis de una clase tiene dos componentes: expresiones de clases y declaraciones de clases.
                    <p align="justify">
                      Una manera de definir una clase es mediante una declaración de clase. Para declarar una clase, se utiliza la palabra reservada class y un nombre para la clase.
                    <p align="justify">
                      Una importante diferencia entre las declaraciones de funciones y las declaraciones de clases es que las declaraciones de funciones son alojadas y las declaraciones de clases no lo son. En primer lugar necesitas declarar tu clase y luego acceder a ella.
                    <p align="justify">
                      Una expresión de clase es otra manera de definir una clase. Las expresiones de clase pueden ser nombradas o anónimas. El nombre dado a la expresión de clase nombrada es local dentro del cuerpo de la misma.
                    <h3 id="caracteristicas">
                        Características
                    </h3>
                    <p align="justify">
                      <ul>
                        <li>
                          <b>Abstracción:</b> denota las características esenciales de un objeto, donde se capturan sus comportamientos. Cada objeto en el sistema sirve como modelo de un "agente" abstracto que puede realizar trabajo, informar y cambiar su estado, y "comunicarse" con otros objetos en el sistema sin revelar cómo se implementan estas características. Los procesos, las funciones o los métodos pueden también ser abstraídos, y, cuando lo están, una variedad de técnicas son requeridas para ampliar una abstracción. El proceso de abstracción permite seleccionar las características relevantes dentro de un conjunto e identificar comportamientos comunes para definir nuevos tipos de entidades en el mundo real. La abstracción es clave en el proceso de análisis y diseño orientado a objetos, ya que mediante ella podemos llegar a armar un conjunto de clases que permitan modelar la realidad o el problema que se quiere atacar.
                        </li>
                        <li>
                          <b>Encapsulamiento:</b> significa reunir todos los elementos que pueden considerarse pertenecientes a una misma entidad, al mismo nivel de abstracción. Esto permite aumentar la cohesión de los componentes del sistema. Algunos autores confunden este concepto con el principio de ocultación, principalmente porque se suelen emplear conjuntamente.
                        </li>
                        <li>
                          <b>Modularidad:</b> se denomina modularidad a la propiedad que permite subdividir una aplicación en partes más pequeñas (llamadas módulos), cada una de las cuales debe ser tan independiente como sea posible de la aplicación en sí y de las restantes partes. Estos módulos se pueden compilar por separado, pero tienen conexiones con otros módulos. Al igual que la encapsulación, los lenguajes soportan la modularidad de diversas formas.
                        </li>
                        <li>
                          <b>Principio de ocultación:</b> cada objeto está aislado del exterior, es un módulo natural, y cada tipo de objeto expone una interfaz a otros objetos que especifica cómo pueden interactuar con los objetos de la clase. El aislamiento protege a las propiedades de un objeto contra su modificación por quien no tenga derecho a acceder a ellas; solamente los propios métodos internos del objeto pueden acceder a su estado. Esto asegura que otros objetos no puedan cambiar el estado interno de un objeto de manera inesperada, eliminando efectos secundarios e interacciones inesperadas. Algunos lenguajes relajan esto, permitiendo un acceso directo a los datos internos del objeto de una manera controlada y limitando el grado de abstracción. La aplicación entera se reduce a un agregado o rompecabezas de objetos.
                        </li>
                        <li>
                          <b>Polimorfismo:</b> comportamientos diferentes, asociados a objetos distintos, pueden compartir el mismo nombre; al llamarlos por ese nombre se utilizará el comportamiento correspondiente al objeto que se esté usando. O, dicho de otro modo, las referencias y las colecciones de objetos pueden contener objetos de diferentes tipos, y la invocación de un comportamiento en una referencia producirá el comportamiento correcto para el tipo real del objeto referenciado. Cuando esto ocurre en "tiempo de ejecución", esta última característica se llama asignación tardía o asignación dinámica. Algunos lenguajes proporcionan medios más estáticos (en "tiempo de compilación") de polimorfismo, tales como las plantillas y la sobrecarga de operadores de C++.
                        </li>
                        <li>
                          <b>Herencia:</b> las clases no están aisladas, sino que se relacionan entre sí, formando una jerarquía de clasificación. Los objetos heredan las propiedades y el comportamiento de todas las clases a las que pertenecen. La herencia organiza y facilita el polimorfismo y el encapsulamiento, permitiendo a los objetos ser definidos y creados como tipos especializados de objetos preexistentes. Estos pueden compartir (y extender) su comportamiento sin tener que volver a implementarlo. Esto suele hacerse habitualmente agrupando los objetos en clases y estas en árboles o enrejados que reflejan un comportamiento común. Cuando un objeto hereda de más de una clase se dice que hay herencia múltiple.
                        </li>
                        <li>
                          <b>Recolección de basura:</b> la recolección de basura o garbage collector es la técnica por la cual el entorno de objetos se encarga de destruir automáticamente, y por tanto desvincular la memoria asociada, los objetos que hayan quedado sin ninguna referencia a ellos. Esto significa que el programador no debe preocuparse por la asignación o liberación de memoria, ya que el entorno la asignará al crear un nuevo objeto y la liberará cuando nadie lo esté usando.
                        </li>
                      </ul>
                    <h3 id="ventajas">
                        Ventajas y Desventajas
                    </h3>
                    <p align="justify">
                      Vamos a ver las ventajas más importantes de la programación orientada a objetos:
                      <ul>
                        <li>
                          <b>Reusabilidad</b>: Cuando hemos diseñado adecuadamente las clases, se pueden usar en distintas partes del programa y en numerosos proyectos.
                        </li>
                        <li>
                          <b>Mantenibilidad</b>: Debido a las sencillez para abstraer el problema, los programas orientados a objetos son más sencillos de leer y comprender, pues nos permiten ocultar detalles de implementación dejando visibles sólo aquellos detalles más relevantes.
                        </li>
                        <li>
                          <b>Modificabilidad</b>: La facilidad de añadir, suprimir o modificar nuevos objetos nos permite hacer modificaciones de una forma muy sencilla.
                        </li>
                        <li>
                          <b>Fiabilidad</b>: Al dividir el problema en partes más pequeñas podemos probarlas de manera independiente y aislar mucho más fácilmente los posibles errores que puedan surgir.
                        </li>
                      </ul>
                    <p align="justify">
                      La programación orientada a objetos presenta también algunas desventajas como pueden ser:
                      <ul>
                        <li>
                          Cambio en la forma de pensar de la programación tradicional a la orientada a objetos.
                        </li>
                        <li>
                          La ejecución de programas orientados a objetos es más lenta.
                        </li>
                        <li>
                          La necesidad de utilizar bibliotecas de clases obliga a su aprendizaje y entrenamiento.
                        </li>
                      </ul>
                </div>
            </div>
            <div id="footer">
                Página creada por Víctor Alfonso Mantilla Villamizar. 2019<br>Correo electrónico: vmantillav@gmail.com
            </div>
        </div>
    </body>
</html>
